searchData={"items":[{"type":"behaviour","title":"EAGL.WindowBehaviour","doc":"Behaviour for OpenGL window management.\nHandles window creation, OpenGL context setup, and event loop management.","ref":"EAGL.WindowBehaviour.html"},{"type":"callback","title":"EAGL.WindowBehaviour.cleanup/1","doc":"Called when the window is being closed.\nShould clean up resources in state.","ref":"EAGL.WindowBehaviour.html#c:cleanup/1"},{"type":"callback","title":"EAGL.WindowBehaviour.handle_event/2","doc":"Called when an event occurs (keyboard, mouse, etc.).\nThis callback is optional. If not implemented, events are ignored.\nShould return {:ok, new_state} to continue with updated state.","ref":"EAGL.WindowBehaviour.html#c:handle_event/2"},{"type":"callback","title":"EAGL.WindowBehaviour.render/3","doc":"Called when the window needs to be rendered.\nThe OpenGL context is already current and the viewport is set.","ref":"EAGL.WindowBehaviour.html#c:render/3"},{"type":"callback","title":"EAGL.WindowBehaviour.setup/0","doc":"Called when the OpenGL context is ready and shaders should be created.\nShould return {:ok, state} or {:error, reason}","ref":"EAGL.WindowBehaviour.html#c:setup/0"},{"type":"module","title":"WX.Const","doc":"wxWidgets constants for GUI and OpenGL canvas management.\nUse this module to inject wxWidgets constants as module attributes.","ref":"WX.Const.html"},{"type":"module","title":"Usage - WX.Const","doc":"defmodule MyModule do\n      use WX.Const\n\n      # Now you can use @wx_vertical, @wx_gl_rgba, @wx_expand, etc.\n    end","ref":"WX.Const.html#module-usage"},{"type":"module","title":"Categories - WX.Const","doc":"This module provides constants for:\n- OpenGL canvas attributes (WX_GL_*)\n- Layout directions and sizer flags\n- Window styles and background styles\n- Event types and window management","ref":"WX.Const.html#module-categories"},{"type":"module","title":"EAGL.Buffer","doc":"Helper functions for OpenGL buffer and vertex array object management.\nProvides convenient wrappers for common VAO/VBO/EBO operations.","ref":"EAGL.Buffer.html"},{"type":"function","title":"EAGL.Buffer.create_indexed_array/3","doc":"Creates a VAO with VBO and EBO for indexed geometry.\nReturns {vao, vbo, ebo} tuple.","ref":"EAGL.Buffer.html#create_indexed_array/3"},{"type":"function","title":"Parameters - EAGL.Buffer.create_indexed_array/3","doc":"- vertices: List of floats representing vertex data\n- indices: List of integers representing vertex indices\n- attribute_configs: List of attribute configurations\n  Each config is {location, size, type, normalized, stride, offset}","ref":"EAGL.Buffer.html#create_indexed_array/3-parameters"},{"type":"function","title":"Example - EAGL.Buffer.create_indexed_array/3","doc":"vertices = [0.5, 0.5, 0.0, 0.5, -0.5, 0.0, -0.5, -0.5, 0.0, -0.5, 0.5, 0.0]\n    indices = [0, 1, 3, 1, 2, 3]\n    {vao, vbo, ebo} = create_indexed_array(vertices, indices, [{0, 3, @gl_float, @gl_false, 0, 0}])","ref":"EAGL.Buffer.html#create_indexed_array/3-example"},{"type":"function","title":"EAGL.Buffer.create_indexed_position_array/2","doc":"Creates a simple indexed VAO with position-only vertices (3 floats per vertex).\nConvenience wrapper for indexed geometry with positions only.","ref":"EAGL.Buffer.html#create_indexed_position_array/2"},{"type":"function","title":"Example - EAGL.Buffer.create_indexed_position_array/2","doc":"vertices = [0.5, 0.5, 0.0, 0.5, -0.5, 0.0, -0.5, -0.5, 0.0, -0.5, 0.5, 0.0]\n    indices = [0, 1, 3, 1, 2, 3]  # Two triangles forming a rectangle\n    {vao, vbo, ebo} = create_indexed_position_array(vertices, indices)","ref":"EAGL.Buffer.html#create_indexed_position_array/2-example"},{"type":"function","title":"EAGL.Buffer.create_position_array/1","doc":"Creates a simple VAO with position-only vertices (3 floats per vertex).\nConvenience wrapper for the most common case.","ref":"EAGL.Buffer.html#create_position_array/1"},{"type":"function","title":"Example - EAGL.Buffer.create_position_array/1","doc":"vertices = [-0.5, -0.5, 0.0, 0.5, -0.5, 0.0, 0.0, 0.5, 0.0]\n    {vao, vbo} = create_position_array(vertices)","ref":"EAGL.Buffer.html#create_position_array/1-example"},{"type":"function","title":"EAGL.Buffer.create_vertex_array/2","doc":"Creates a VAO with a single VBO containing vertex data.\nReturns {vao, vbo} tuple.","ref":"EAGL.Buffer.html#create_vertex_array/2"},{"type":"function","title":"Parameters - EAGL.Buffer.create_vertex_array/2","doc":"- vertices: List of floats representing vertex data\n- attribute_configs: List of attribute configurations\n  Each config is {location, size, type, normalized, stride, offset}","ref":"EAGL.Buffer.html#create_vertex_array/2-parameters"},{"type":"function","title":"Example - EAGL.Buffer.create_vertex_array/2","doc":"vertices = [-0.5, -0.5, 0.0, 0.5, -0.5, 0.0, 0.0, 0.5, 0.0]\n    {vao, vbo} = create_vertex_array(vertices, [{0, 3, @gl_float, @gl_false, 0, 0}])","ref":"EAGL.Buffer.html#create_vertex_array/2-example"},{"type":"function","title":"EAGL.Buffer.delete_indexed_array/3","doc":"Deletes a VAO and its associated VBO and EBO.","ref":"EAGL.Buffer.html#delete_indexed_array/3"},{"type":"function","title":"EAGL.Buffer.delete_vertex_array/2","doc":"Deletes a VAO and its associated VBOs.","ref":"EAGL.Buffer.html#delete_vertex_array/2"},{"type":"function","title":"EAGL.Buffer.indices_to_binary/1","doc":"Converts a list of indices to binary format for OpenGL.","ref":"EAGL.Buffer.html#indices_to_binary/1"},{"type":"function","title":"EAGL.Buffer.vertices_to_binary/1","doc":"Converts a list of vertex floats to binary format for OpenGL.","ref":"EAGL.Buffer.html#vertices_to_binary/1"},{"type":"module","title":"EAGL.Error","doc":"OpenGL error handling utilities.\nProvides functions for checking and reporting OpenGL errors.","ref":"EAGL.Error.html"},{"type":"function","title":"EAGL.Error.check/1","doc":"Check for OpenGL errors and print them.\nSimilar to Wings3D's check_error/2 function.","ref":"EAGL.Error.html#check/1"},{"type":"function","title":"Parameters - EAGL.Error.check/1","doc":"- context: String describing the context where the error check is performed","ref":"EAGL.Error.html#check/1-parameters"},{"type":"function","title":"Returns - EAGL.Error.check/1","doc":"- `:ok` if no error\n- `{:error, error_message}` if an error occurred","ref":"EAGL.Error.html#check/1-returns"},{"type":"function","title":"Example - EAGL.Error.check/1","doc":"EAGL.Error.check(\"After buffer creation\")\n    EAGL.Error.check(\"Shader compilation\")","ref":"EAGL.Error.html#check/1-example"},{"type":"function","title":"EAGL.Error.check!/1","doc":"Check for OpenGL errors and raise an exception if one is found.\nUseful for development and debugging.","ref":"EAGL.Error.html#check!/1"},{"type":"function","title":"EAGL.Error.error_string/1","doc":"Get a human-readable string for an OpenGL error code.\nSimilar to Wings3D's error_string/1 function.","ref":"EAGL.Error.html#error_string/1"},{"type":"module","title":"EAGL.Math","doc":"Port of the OpenGL GLM header files to Elixir.\nNote that Erlang wx OpenGL represents matricies and vectors as\nflat tuples nested in lists.","ref":"EAGL.Math.html"},{"type":"function","title":"EAGL.Math.abs_val/1","doc":"Absolute value.","ref":"EAGL.Math.html#abs_val/1"},{"type":"function","title":"EAGL.Math.angle_between/2","doc":"Calculate angle between two vectors in radians.","ref":"EAGL.Math.html#angle_between/2"},{"type":"function","title":"EAGL.Math.clamp/3","doc":"Clamp value between min and max.","ref":"EAGL.Math.html#clamp/3"},{"type":"function","title":"EAGL.Math.cross/2","doc":"Compute the cross product of two 3D vectors.","ref":"EAGL.Math.html#cross/2"},{"type":"function","title":"EAGL.Math.degrees/1","doc":"Convert radians to degrees.","ref":"EAGL.Math.html#degrees/1"},{"type":"function","title":"EAGL.Math.distance/2","doc":"Calculate the distance between two points (vectors).","ref":"EAGL.Math.html#distance/2"},{"type":"function","title":"EAGL.Math.distance_squared/2","doc":"Calculate the squared distance between two points (avoids sqrt).","ref":"EAGL.Math.html#distance_squared/2"},{"type":"function","title":"EAGL.Math.dot/2","doc":"Compute the dot product of two vectors (2D, 3D, or 4D).","ref":"EAGL.Math.html#dot/2"},{"type":"function","title":"EAGL.Math.face_normal/3","doc":"Calculate face normal from three vertices (assumes counter-clockwise winding).","ref":"EAGL.Math.html#face_normal/3"},{"type":"function","title":"EAGL.Math.fract/1","doc":"Fractional part of x (x - floor(x)).","ref":"EAGL.Math.html#fract/1"},{"type":"function","title":"EAGL.Math.inverse_sqrt/1","doc":"Fast inverse square root approximation.","ref":"EAGL.Math.html#inverse_sqrt/1"},{"type":"function","title":"EAGL.Math.length_squared/1","doc":"Compute the squared length of a vector (avoids sqrt for performance).","ref":"EAGL.Math.html#length_squared/1"},{"type":"function","title":"EAGL.Math.lerp/3","doc":"Linear interpolation between two values.","ref":"EAGL.Math.html#lerp/3"},{"type":"type","title":"EAGL.Math.mat2/0","doc":"","ref":"EAGL.Math.html#t:mat2/0"},{"type":"function","title":"EAGL.Math.mat2/4","doc":"Create a 2x2 matrix.","ref":"EAGL.Math.html#mat2/4"},{"type":"function","title":"EAGL.Math.mat2_identity/0","doc":"Create a 2x2 identity matrix.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat2_identity/0"},{"type":"type","title":"EAGL.Math.mat3/0","doc":"","ref":"EAGL.Math.html#t:mat3/0"},{"type":"function","title":"EAGL.Math.mat3/9","doc":"Create a 3x3 matrix.","ref":"EAGL.Math.html#mat3/9"},{"type":"function","title":"EAGL.Math.mat3_identity/0","doc":"Create a 3x3 identity matrix.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat3_identity/0"},{"type":"function","title":"EAGL.Math.mat3_mul/2","doc":"Multiply two 3x3 matrices.\nAll matrices are in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat3_mul/2"},{"type":"function","title":"EAGL.Math.mat3_transpose/1","doc":"Transpose a 3x3 matrix.\nInput and output matrices are in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat3_transpose/1"},{"type":"type","title":"EAGL.Math.mat4/0","doc":"","ref":"EAGL.Math.html#t:mat4/0"},{"type":"function","title":"EAGL.Math.mat4/16","doc":"Create a 4x4 matrix.","ref":"EAGL.Math.html#mat4/16"},{"type":"function","title":"EAGL.Math.mat4_identity/0","doc":"Create a 4x4 identity matrix.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_identity/0"},{"type":"function","title":"EAGL.Math.mat4_inverse/1","doc":"Create the inverse of a 4x4 matrix using the adjugate method.\nReturns the original matrix if it's not invertible (determinant is zero).\nInput and output matrices are in column-major order for OpenGL compatibility.\nNote this is the only function not from the original OpenGl GLM library.","ref":"EAGL.Math.html#mat4_inverse/1"},{"type":"function","title":"EAGL.Math.mat4_look_at/3","doc":"Create a look-at view matrix.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_look_at/3"},{"type":"function","title":"EAGL.Math.mat4_mul/2","doc":"Multiply two 4x4 matrices.\nAll matrices are in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_mul/2"},{"type":"function","title":"EAGL.Math.mat4_ortho/6","doc":"Create an orthographic projection matrix.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_ortho/6"},{"type":"function","title":"EAGL.Math.mat4_perspective/4","doc":"Create a perspective projection matrix.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_perspective/4"},{"type":"function","title":"EAGL.Math.mat4_rotate/2","doc":"Create a rotation matrix from axis and angle.","ref":"EAGL.Math.html#mat4_rotate/2"},{"type":"function","title":"EAGL.Math.mat4_rotate_x/1","doc":"Create a rotation matrix around the X axis.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_rotate_x/1"},{"type":"function","title":"EAGL.Math.mat4_rotate_y/1","doc":"Create a rotation matrix around the Y axis.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_rotate_y/1"},{"type":"function","title":"EAGL.Math.mat4_rotate_z/1","doc":"Create a rotation matrix around the Z axis.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_rotate_z/1"},{"type":"function","title":"EAGL.Math.mat4_scale/1","doc":"Create a scale matrix.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_scale/1"},{"type":"function","title":"EAGL.Math.mat4_transform_point/2","doc":"Multiply a 3D vector by a 4x4 matrix (treating vector as point with w=1).\nReturns a 3D vector with the w component divided out.","ref":"EAGL.Math.html#mat4_transform_point/2"},{"type":"function","title":"EAGL.Math.mat4_transform_vec4/2","doc":"Multiply a 4D vector by a 4x4 matrix.","ref":"EAGL.Math.html#mat4_transform_vec4/2"},{"type":"function","title":"EAGL.Math.mat4_transform_vector/2","doc":"Multiply a 3D vector by a 4x4 matrix (treating vector as direction with w=0).\nUsed for transforming direction vectors (normals, etc.) where translation should be ignored.","ref":"EAGL.Math.html#mat4_transform_vector/2"},{"type":"function","title":"EAGL.Math.mat4_translate/1","doc":"Create a translation matrix.\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_translate/1"},{"type":"function","title":"EAGL.Math.mat4_transpose/1","doc":"Transpose a 4x4 matrix.\nInput and output matrices are in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#mat4_transpose/1"},{"type":"function","title":"EAGL.Math.mix/3","doc":"Mix (linear interpolation) between two values.","ref":"EAGL.Math.html#mix/3"},{"type":"function","title":"EAGL.Math.mod/2","doc":"Modulo operation that works with floats.","ref":"EAGL.Math.html#mod/2"},{"type":"function","title":"EAGL.Math.normalize/1","doc":"Normalize a vector to unit length (2D, 3D, or 4D).","ref":"EAGL.Math.html#normalize/1"},{"type":"function","title":"EAGL.Math.parallel?/3","doc":"Check if two vectors are parallel (dot product close to ±1).","ref":"EAGL.Math.html#parallel?/3"},{"type":"function","title":"EAGL.Math.perpendicular?/3","doc":"Check if two vectors are perpendicular (dot product close to 0).","ref":"EAGL.Math.html#perpendicular?/3"},{"type":"function","title":"EAGL.Math.project/2","doc":"Project vector a onto vector b.","ref":"EAGL.Math.html#project/2"},{"type":"type","title":"EAGL.Math.quat/0","doc":"","ref":"EAGL.Math.html#t:quat/0"},{"type":"function","title":"EAGL.Math.quat/4","doc":"Create a quaternion.\nQuaternions are represented as {x, y, z, w} where w is the scalar component.\nThis follows the (x, y, z, w) convention commonly used in graphics programming.","ref":"EAGL.Math.html#quat/4"},{"type":"function","title":"EAGL.Math.quat_conjugate/1","doc":"Conjugate a quaternion (negate x, y, z components).","ref":"EAGL.Math.html#quat_conjugate/1"},{"type":"function","title":"EAGL.Math.quat_from_axis_angle/2","doc":"Create a quaternion from axis-angle representation.","ref":"EAGL.Math.html#quat_from_axis_angle/2"},{"type":"function","title":"EAGL.Math.quat_from_euler/3","doc":"Create a quaternion from Euler angles (pitch, yaw, roll in radians).","ref":"EAGL.Math.html#quat_from_euler/3"},{"type":"function","title":"EAGL.Math.quat_identity/0","doc":"Create an identity quaternion (no rotation).","ref":"EAGL.Math.html#quat_identity/0"},{"type":"function","title":"EAGL.Math.quat_mul/2","doc":"Multiply two quaternions.","ref":"EAGL.Math.html#quat_mul/2"},{"type":"function","title":"EAGL.Math.quat_normalize/1","doc":"Normalize a quaternion.","ref":"EAGL.Math.html#quat_normalize/1"},{"type":"function","title":"EAGL.Math.quat_rotate_vec3/2","doc":"Rotate a 3D vector by a quaternion.","ref":"EAGL.Math.html#quat_rotate_vec3/2"},{"type":"function","title":"EAGL.Math.quat_slerp/3","doc":"Spherical linear interpolation between two quaternions.","ref":"EAGL.Math.html#quat_slerp/3"},{"type":"function","title":"EAGL.Math.quat_to_mat3/1","doc":"Convert quaternion to rotation matrix (3x3).\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#quat_to_mat3/1"},{"type":"function","title":"EAGL.Math.quat_to_mat4/1","doc":"Convert quaternion to rotation matrix (4x4).\nMatrix is stored in column-major order for OpenGL compatibility.","ref":"EAGL.Math.html#quat_to_mat4/1"},{"type":"function","title":"EAGL.Math.radians/1","doc":"Convert degrees to radians.","ref":"EAGL.Math.html#radians/1"},{"type":"function","title":"EAGL.Math.reflect/2","doc":"Reflect a vector around a normal.","ref":"EAGL.Math.html#reflect/2"},{"type":"function","title":"EAGL.Math.refract/3","doc":"Refract a vector around a normal with given refractive index ratio.","ref":"EAGL.Math.html#refract/3"},{"type":"function","title":"EAGL.Math.reject/2","doc":"Reject vector a from vector b (perpendicular component).","ref":"EAGL.Math.html#reject/2"},{"type":"function","title":"EAGL.Math.sign/1","doc":"Sign function (-1, 0, or 1).","ref":"EAGL.Math.html#sign/1"},{"type":"function","title":"EAGL.Math.smooth_step/3","doc":"Smooth step function (Hermite interpolation).","ref":"EAGL.Math.html#smooth_step/3"},{"type":"function","title":"EAGL.Math.step/2","doc":"Step function (returns 0.0 if x < edge, 1.0 otherwise).","ref":"EAGL.Math.html#step/2"},{"type":"type","title":"EAGL.Math.vec2/0","doc":"","ref":"EAGL.Math.html#t:vec2/0"},{"type":"function","title":"EAGL.Math.vec2/2","doc":"Create a 2D vector.","ref":"EAGL.Math.html#vec2/2"},{"type":"function","title":"EAGL.Math.vec2_zero/0","doc":"Create a zero vector (2D).","ref":"EAGL.Math.html#vec2_zero/0"},{"type":"type","title":"EAGL.Math.vec3/0","doc":"","ref":"EAGL.Math.html#t:vec3/0"},{"type":"function","title":"EAGL.Math.vec3/3","doc":"Create a 3D vector.","ref":"EAGL.Math.html#vec3/3"},{"type":"function","title":"EAGL.Math.vec3_one/0","doc":"Create a 3D vector with all components set to 1.","ref":"EAGL.Math.html#vec3_one/0"},{"type":"function","title":"EAGL.Math.vec3_unit_x/0","doc":"Create the X unit vector (1, 0, 0).","ref":"EAGL.Math.html#vec3_unit_x/0"},{"type":"function","title":"EAGL.Math.vec3_unit_y/0","doc":"Create the Y unit vector (0, 1, 0).","ref":"EAGL.Math.html#vec3_unit_y/0"},{"type":"function","title":"EAGL.Math.vec3_unit_z/0","doc":"Create the Z unit vector (0, 0, 1).","ref":"EAGL.Math.html#vec3_unit_z/0"},{"type":"function","title":"EAGL.Math.vec3_zero/0","doc":"Create a zero vector (3D).","ref":"EAGL.Math.html#vec3_zero/0"},{"type":"type","title":"EAGL.Math.vec4/0","doc":"","ref":"EAGL.Math.html#t:vec4/0"},{"type":"function","title":"EAGL.Math.vec4/4","doc":"Create a 4D vector.","ref":"EAGL.Math.html#vec4/4"},{"type":"function","title":"EAGL.Math.vec4_zero/0","doc":"Create a zero vector (4D).","ref":"EAGL.Math.html#vec4_zero/0"},{"type":"function","title":"EAGL.Math.vec_add/2","doc":"Add two vectors component-wise.","ref":"EAGL.Math.html#vec_add/2"},{"type":"function","title":"EAGL.Math.vec_length/1","doc":"Compute the length (magnitude) of a vector (2D, 3D, or 4D).","ref":"EAGL.Math.html#vec_length/1"},{"type":"function","title":"EAGL.Math.vec_lerp/3","doc":"Linear interpolation between two vectors.","ref":"EAGL.Math.html#vec_lerp/3"},{"type":"function","title":"EAGL.Math.vec_negate/1","doc":"Negate a vector (multiply by -1).","ref":"EAGL.Math.html#vec_negate/1"},{"type":"function","title":"EAGL.Math.vec_scale/2","doc":"Multiply a vector by a scalar.","ref":"EAGL.Math.html#vec_scale/2"},{"type":"function","title":"EAGL.Math.vec_sub/2","doc":"Subtract two vectors component-wise.","ref":"EAGL.Math.html#vec_sub/2"},{"type":"module","title":"EAGL.Shader","doc":"Module for OpenGL shader management.\nHandles shader creation, compilation, and program linking.","ref":"EAGL.Shader.html"},{"type":"function","title":"EAGL.Shader.cache_uniform_locations/2","doc":"Convenience function to cache uniform locations for repeated use.\nReturns a map of uniform names to their locations.","ref":"EAGL.Shader.html#cache_uniform_locations/2"},{"type":"function","title":"EAGL.Shader.check_compile_status/1","doc":"Checks if a shader compiled successfully.","ref":"EAGL.Shader.html#check_compile_status/1"},{"type":"function","title":"EAGL.Shader.check_link_status/1","doc":"","ref":"EAGL.Shader.html#check_link_status/1"},{"type":"function","title":"EAGL.Shader.cleanup_program/1","doc":"Cleans up a shader program and all its attached shaders.","ref":"EAGL.Shader.html#cleanup_program/1"},{"type":"function","title":"EAGL.Shader.cleanup_shader/1","doc":"Cleans up a shader.","ref":"EAGL.Shader.html#cleanup_shader/1"},{"type":"function","title":"EAGL.Shader.create_attach_link/1","doc":"Creates a program, attaches shaders, links, and returns the link status.","ref":"EAGL.Shader.html#create_attach_link/1"},{"type":"function","title":"EAGL.Shader.create_shader/2","doc":"Creates and compiles a shader of the specified type with the given source code.\nReturns the shader ID.","ref":"EAGL.Shader.html#create_shader/2"},{"type":"function","title":"EAGL.Shader.get_uniform_location/2","doc":"Get uniform location for a program. Similar to wings_gl:uloc/2.\nReturns the uniform location or -1 if not found.","ref":"EAGL.Shader.html#get_uniform_location/2"},{"type":"type","title":"EAGL.Shader.mat2/0","doc":"","ref":"EAGL.Shader.html#t:mat2/0"},{"type":"type","title":"EAGL.Shader.mat3/0","doc":"","ref":"EAGL.Shader.html#t:mat3/0"},{"type":"type","title":"EAGL.Shader.mat4/0","doc":"","ref":"EAGL.Shader.html#t:mat4/0"},{"type":"type","title":"EAGL.Shader.quat/0","doc":"","ref":"EAGL.Shader.html#t:quat/0"},{"type":"function","title":"EAGL.Shader.set_uniform/3","doc":"Set uniform value with automatic type detection. Similar to wings_gl:set_uloc/3.\nSupports various EAGL.Math types and basic values.","ref":"EAGL.Shader.html#set_uniform/3"},{"type":"function","title":"EAGL.Shader.set_uniform_at_location/2","doc":"Set uniform value at a specific location with automatic type detection.","ref":"EAGL.Shader.html#set_uniform_at_location/2"},{"type":"function","title":"EAGL.Shader.set_uniforms/2","doc":"Convenience function to set multiple uniforms at once.\nTakes a program and a keyword list of uniform_name -> value pairs.","ref":"EAGL.Shader.html#set_uniforms/2"},{"type":"type","title":"EAGL.Shader.uniform_value/0","doc":"","ref":"EAGL.Shader.html#t:uniform_value/0"},{"type":"type","title":"EAGL.Shader.vec2/0","doc":"","ref":"EAGL.Shader.html#t:vec2/0"},{"type":"type","title":"EAGL.Shader.vec3/0","doc":"","ref":"EAGL.Shader.html#t:vec3/0"},{"type":"type","title":"EAGL.Shader.vec4/0","doc":"","ref":"EAGL.Shader.html#t:vec4/0"},{"type":"module","title":"EAGL.Window","doc":"Utility module for OpenGL window management.\nHandles window creation, OpenGL context setup, and event loop management.","ref":"EAGL.Window.html"},{"type":"function","title":"EAGL.Window.run/2","doc":"Creates and runs an OpenGL window using the given callback module.\nThe callback module must implement the GLWindowBehaviour.","ref":"EAGL.Window.html#run/2"},{"type":"function","title":"EAGL.Window.run/3","doc":"","ref":"EAGL.Window.html#run/3"},{"type":"module","title":"EAGL.Model","doc":"Helper module for loading 3D model resources and creating OpenGL vertex array objects.","ref":"EAGL.Model.html"},{"type":"function","title":"EAGL.Model.delete_vao/1","doc":"Deletes a vertex array object and its associated buffers.","ref":"EAGL.Model.html#delete_vao/1"},{"type":"function","title":"EAGL.Model.list_models/0","doc":"Lists all available models in the priv/models directory.","ref":"EAGL.Model.html#list_models/0"},{"type":"function","title":"EAGL.Model.load_model/2","doc":"Loads a model from the priv/models directory.\nReturns the processed model data ready for OpenGL.\n\nOptions:\n  - :flip_normal_direction - boolean, set to true to flip normal direction for all models (default: false)\n                             This works for both models with existing normals and models that need generated normals.\n  - :smooth_normals - boolean, set to true to generate smooth normals by averaging across adjacent faces (default: false)\n                      This gives a smoother appearance by eliminating the faceted look.","ref":"EAGL.Model.html#load_model/2"},{"type":"function","title":"EAGL.Model.load_model_to_vao/2","doc":"Loads a model and creates a VAO with the model data.\nReturns {:ok, %{vao: vao, vertex_count: count}} or {:error, reason}\n\nThe VAO will have the following attributes:\n- Location 0: Vertex positions (vec3)\n- Location 1: Texture coordinates (vec2)\n- Location 2: Normals (vec3)\n\nOptions:\n  - :flip_normal_direction - boolean, set to true to flip normal direction for all models (default: false)\n                             This works for both models with existing normals and models that need generated normals.\n                             Useful when model normals are pointing in the wrong direction for your lighting setup.\n  - :smooth_normals - boolean, set to true to generate smooth normals by averaging across adjacent faces (default: false)\n                      This gives a smoother appearance by eliminating the faceted look.\n                      When true, existing normals are ignored and smooth normals are generated.","ref":"EAGL.Model.html#load_model_to_vao/2"},{"type":"module","title":"EAGL.ObjLoader","doc":"Simple Wavefront OBJ file loader.\nCurrently supports vertices, texture coordinates, normals, and faces.","ref":"EAGL.ObjLoader.html"},{"type":"function","title":"EAGL.ObjLoader.load_obj/2","doc":"Loads an OBJ file and returns vertex data ready for OpenGL.\nReturns {:ok, data} where data is a map containing:\n  - :vertices - List of floats in x,y,z order\n  - :tex_coords - List of floats in u,v order\n  - :normals - List of floats in x,y,z order\n  - :indices - List of integers for indexed drawing\n\nOptions:\n  - :flip_normal_direction - boolean, set to true to flip normal direction for all models (default: false)\n                             This works consistently for both models with existing normals and models that need generated normals.\n                             For models with existing normals: negates all normal components\n                             For models without normals: generates normals with flipped direction\n  - :smooth_normals - boolean, set to true to generate smooth normals by averaging across adjacent faces (default: false)\n                      This gives a smoother appearance by eliminating the faceted look.\n                      When true, existing normals are ignored and smooth normals are generated.","ref":"EAGL.ObjLoader.html#load_obj/2"},{"type":"module","title":"EAGL.Const","doc":"Curated set of 300 OpenGL constants for 3D graphics programming. Additional constants\ncan be added as needed from the 4,925 constants in the wx/include/gl.hrl file.\n\nUse this module to inject OpenGL constants as module attributes.","ref":"EAGL.Const.html"},{"type":"module","title":"Usage - EAGL.Const","doc":"defmodule MyModule do\n      use EAGL.Const\n\n      # Now you can use @gl_vertex_shader, @gl_triangles, @gl_texture_2d, etc.\n    end","ref":"EAGL.Const.html#module-usage"},{"type":"module","title":"Categories - EAGL.Const","doc":"This module provides constants for:\n- Shader types and compilation\n- Buffer types and usage patterns\n- Drawing primitives and polygon modes\n- Data types and formats\n- Textures and sampling\n- Blending and transparency\n- Depth and stencil testing\n- Matrices and transformations\n- Vertex attributes and arrays\n- Framebuffers and attachments\n- And much more...","ref":"EAGL.Const.html#module-categories"},{"type":"module","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1","doc":"Port of LearnOpenGL's Hello Triangle Exercise 1 to EAGL framework.\n\nOriginal: https://learnopengl.com/Getting-started/Hello-Triangle (Exercise 1)\nChapter 1, Section 2.3: Hello Triangle Exercise 1\n\nExercise: Try to draw 2 triangles next to each other using glDrawArrays\nby adding more vertices to your data.\n\nThis example demonstrates:\n- Drawing multiple triangles with a single VAO/VBO\n- Using glDrawArrays with 6 vertices (2 triangles)\n- Positioning triangles side by side in normalized device coordinates\n\nKey concepts:\n- Two separate triangles defined by 6 vertices total\n- Single draw call renders both triangles\n- Left triangle: vertices 0-2, Right triangle: vertices 3-5\n\nRun with: mix run -e \"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1.run_example()\"","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1.html"},{"type":"function","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1.run_example/0","doc":"","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1.html#run_example/0"},{"type":"module","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2","doc":"Port of LearnOpenGL's Hello Triangle Exercise 2 to EAGL framework.\n\nOriginal: https://learnopengl.com/Getting-started/Hello-Triangle (Exercise 2)\nChapter 1, Section 2.4: Hello Triangle Exercise 2\n\nThis example demonstrates:\n- Creating two triangles using a single VAO and VBO\n- Using an Element Buffer Object (EBO) to avoid vertex duplication\n- Drawing with glDrawElements instead of glDrawArrays\n- Efficient vertex data sharing between triangles\n\nThe two triangles share vertices to form a rectangle:\n```\n3 ---- 2\n|    / |\n|   /  |\n|  /   |\n| /    |\n0 ---- 1\n```\n\nRun with: mix run -e \"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2.run_example()\"\nOr use the script: ./priv/scripts/triangle2","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2.html"},{"type":"function","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2.run_example/0","doc":"","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2.html#run_example/0"},{"type":"module","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3","doc":"Port of LearnOpenGL's Hello Triangle Exercise 3 to EAGL framework.\n\nOriginal: https://learnopengl.com/Getting-started/Hello-Triangle (Exercise 3)\nChapter 1, Section 2.5: Hello Triangle Exercise 3\n\nThis example demonstrates:\n- Creating two triangles using separate VAOs and VBOs\n- Using the same vertex shader for both triangles\n- Using different fragment shaders (orange and yellow)\n- Rendering with different shader programs\n\nRun with: mix run -e \"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3.run_example()\"\nOr use the script: ./priv/scripts/triangle","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3.html"},{"type":"function","title":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3.run_example/0","doc":"","ref":"EAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3.html#run_example/0"},{"type":"module","title":"EAGL.Examples.Math","doc":"Comprehensive example demonstrating all EAGL.Math functionality.\nThis showcases vector and quaternion constructor macros, vector operations,\nquaternions, matrices, utility functions, and real-world OpenGL usage patterns.","ref":"EAGL.Examples.Math.html"},{"type":"function","title":"EAGL.Examples.Math.constructor_examples/0","doc":"Example showing various vector and quaternion constructors.","ref":"EAGL.Examples.Math.html#constructor_examples/0"},{"type":"function","title":"EAGL.Examples.Math.lighting_demo/0","doc":"Demonstrate lighting calculations using vectors.","ref":"EAGL.Examples.Math.html#lighting_demo/0"},{"type":"function","title":"EAGL.Examples.Math.matrix_operations_demo/0","doc":"Demonstrate matrix operations.","ref":"EAGL.Examples.Math.html#matrix_operations_demo/0"},{"type":"function","title":"EAGL.Examples.Math.opengl_usage_examples/0","doc":"Example showing how to use these in an OpenGL context.","ref":"EAGL.Examples.Math.html#opengl_usage_examples/0"},{"type":"function","title":"EAGL.Examples.Math.quaternion_operations_demo/0","doc":"Demonstrate quaternion operations.","ref":"EAGL.Examples.Math.html#quaternion_operations_demo/0"},{"type":"function","title":"EAGL.Examples.Math.run_example/0","doc":"Run the math example - consistent interface with other examples.","ref":"EAGL.Examples.Math.html#run_example/0"},{"type":"function","title":"EAGL.Examples.Math.transformation_pipeline_demo/0","doc":"Demonstrate typical OpenGL transformation pipeline.","ref":"EAGL.Examples.Math.html#transformation_pipeline_demo/0"},{"type":"function","title":"EAGL.Examples.Math.utility_functions_demo/0","doc":"Demonstrate utility and trigonometric functions.","ref":"EAGL.Examples.Math.html#utility_functions_demo/0"},{"type":"function","title":"EAGL.Examples.Math.vector_operations_demo/0","doc":"Demonstrate vector operations.","ref":"EAGL.Examples.Math.html#vector_operations_demo/0"},{"type":"module","title":"EAGL.Examples.Teapot","doc":"Draw a 3D teapot with Phong shading.\nPress ESC to quit","ref":"EAGL.Examples.Teapot.html"},{"type":"function","title":"EAGL.Examples.Teapot.run_example/0","doc":"","ref":"EAGL.Examples.Teapot.html#run_example/0"},{"type":"extras","title":"EAGL","doc":"# EAGL\n\n![An Eagle carrying a teapot](assets/eagl_logo_grey_on_transparent.png \"EAGL Logo\")\n\nMake it **EA**sier to work with Open**GL** in Elixir, using the Erlang WX bindings to OpenGL.","ref":"readme.html"},{"type":"extras","title":"Overview - EAGL","doc":"Most examples of working with OpenGL are written in C++ or C# (Unity). The purpose of the EAGL library is to\n- Make it easier to translate OpenGL tutorials and examples from resources like [Learn OpenGL](https://learnopengl.com) into Elixir. \n- Provide basic helper functions to bridge the gap between idiomatic Elixir and OpenGL's state machine, using the Wings 3D Erlang source as a guide.\n- Enable other libraries and apps to build on this one - e.g. there should be Unity-like tool for the BEAM.\n\nNon-goals:\n- Wrapping of the Erlang wx library\n- A Shader DSL\n- A UI layout/component library\n- 3D mesh modelling (leave that to Wings 3D, Blender etc)","ref":"readme.html#overview"},{"type":"extras","title":"Quick Start - EAGL","doc":"```elixir\n# Add to mix.exs\n{:eagl, \"~> 0.1.0\"}\n```","ref":"readme.html#quick-start"},{"type":"extras","title":"Running Examples - EAGL","doc":"EAGL includes several examples to demonstrate its capabilities. Use the unified examples runner:\n\n```bash\n# Interactive menu with all examples\n./priv/scripts/run_examples\n```\n\nAvailable examples:\n1. **Math Example** - Comprehensive demonstration of all EAGL.Math functionality (terminal-based)\n2. **Teapot Example** - 3D teapot with Phong shading (OpenGL window)\n3. **LearnOpenGL 2.3** - Hello Triangle Exercise 1 (glDrawArrays)\n4. **LearnOpenGL 2.4** - Hello Triangle Exercise 2 (Element Buffer Objects)\n5. **LearnOpenGL 2.5** - Hello Triangle Exercise 3 (Multiple Shader Programs)","ref":"readme.html#running-examples"},{"type":"extras","title":"Usage - EAGL","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Math Operations - EAGL","doc":"```elixir\nimport EAGL.Math\n\n# Vector operations\nposition = vec3(1.0, 2.0, 3.0)\ndirection = vec3(0.0, 1.0, 0.0) \nresult = vec_add(position, direction)\nlength = vec_length(position)\n\n# Matrix transformations\nmodel = mat4_translate(vec3(5.0, 0.0, 0.0))\nview = mat4_look_at(\n  vec3(0.0, 0.0, 5.0),  # eye\n  vec3(0.0, 0.0, 0.0),  # target\n  vec3(0.0, 1.0, 0.0)   # up\n)\nprojection = mat4_perspective(radians(45.0), 16.0/9.0, 0.1, 100.0)\n```","ref":"readme.html#math-operations"},{"type":"extras","title":"Shader Management - EAGL","doc":"```elixir\nimport EAGL.Shader\n\n# Compile and link shaders\n{:ok, vertex} = create_shader(@gl_vertex_shader, \"vertex.glsl\")\n{:ok, fragment} = create_shader(@gl_fragment_shader, \"fragment.glsl\")\n{:ok, program} = create_attach_link([vertex, fragment])\n\n# Set uniforms with automatic type detection\nset_uniform(program, \"model_matrix\", model_matrix)\nset_uniform(program, \"light_position\", vec3(10.0, 10.0, 5.0))\nset_uniform(program, \"time\", :erlang.monotonic_time(:millisecond))\n\n# Or set multiple uniforms at once\nset_uniforms(program, [\n  model: model_matrix,\n  view: view_matrix,\n  projection: projection_matrix,\n  light_position: vec3(10.0, 10.0, 5.0),\n  light_color: vec3(1.0, 1.0, 1.0)\n])\n```","ref":"readme.html#shader-management"},{"type":"extras","title":"Uniform Helper Features (from Wings 3D) - EAGL","doc":"The uniform helpers automatically detect the type of EAGL.Math values:\n\n- `vec2/3/4` → `glUniform2f/3f/4f`\n- `mat2/3/4` → `glUniformMatrix2fv/3fv/4fv` \n- Numbers → `glUniform1f/1i`\n- Booleans → `glUniform1i` (0 or 1)\n\nThis eliminates the need to manually unpack vectors or handle different uniform types.","ref":"readme.html#uniform-helper-features-from-wings-3d"},{"type":"extras","title":"Model Loading - EAGL","doc":"```elixir\nimport EAGL.Model\n\n# Load OBJ file with automatic normal generation\n{:ok, model} = load_model_to_vao(\"teapot.obj\")\n\n# Render the model\n:gl.bindVertexArray(model.vao)\n:gl.drawElements(@gl_triangles, model.vertex_count, @gl_unsigned_int, 0)\n```","ref":"readme.html#model-loading"},{"type":"extras","title":"Buffer Management - EAGL","doc":"```elixir\nimport EAGL.Buffer\n\n# Create simple position-only VAO/VBO (convenience function)\nvertices = [-0.5, -0.5, 0.0, 0.5, -0.5, 0.0, 0.0, 0.5, 0.0]\n{vao, vbo} = create_position_array(vertices)\n\n# Or create with custom attributes (general function)\n{vao, vbo} = create_vertex_array(vertices, [\n  {0, 3, @gl_float, @gl_false, 0, 0}  # position at location 0\n])\n\n# Clean up\ndelete_vertex_array(vao, vbo)\n```","ref":"readme.html#buffer-management"},{"type":"extras","title":"Error Handling - EAGL","doc":"```elixir\nimport EAGL.Error\n\n# Check for OpenGL errors with context\ncheck(\"After buffer creation\")  # Returns :ok or {:error, message}\n\n# Get human-readable error string for error code\nerror_string(1280)  # \"GL_INVALID_ENUM\"\n\n# Check and raise on error (useful for debugging)\ncheck!(\"Critical operation\")  # Raises RuntimeError if error found\n```","ref":"readme.html#error-handling"},{"type":"extras","title":"Window Creation - EAGL","doc":"```elixir\ndefmodule MyApp do\n  use EAGL.Window\n  import EAGL.Shader\n  import EAGL.Math\n\n  def run_example do\n    EAGL.Window.run(__MODULE__, \"My OpenGL App\")\n  end\n\n  @impl true\n  def setup do\n    # Initialize shaders, load models, etc.\n    {:ok, initial_state}\n  end\n\n  @impl true\n  def render(width, height, state) do\n    # Render frame\n    :ok\n  end\n\n  @impl true\n  def cleanup(state) do\n    # Clean up resources\n    :ok\n  end\nend\n```","ref":"readme.html#window-creation"},{"type":"extras","title":"Library Structure - EAGL","doc":"- `EAGL.Math` - Vector and matrix math operations (GLM-inspired)\n- `EAGL.Shader` - Shader compilation and uniform management (Wings3D-inspired)\n- `EAGL.Model` - 3D model loading and vertex array management\n- `EAGL.Buffer` - VAO/VBO helper functions\n- `EAGL.Error` - OpenGL error checking and reporting\n- `EAGL.Window` - OpenGL context and window management\n- `EAGL.Const` - OpenGL constants","ref":"readme.html#library-structure"},{"type":"extras","title":"Math Library - EAGL","doc":"Comprehensive 3D math library supporting:\n\n- **Vectors**: 2D, 3D, 4D vector operations with constructor macros\n- **Matrices**: 2x2, 3x3, 4x4 matrix operations with transformation functions\n- **Quaternions**: Rotation representation, SLERP, and conversion functions\n- **Utilities**: Trigonometry, interpolation, clamping, and geometric functions\n- **OpenGL Integration**: All functions work with Erlang's OpenGL binding format\n\nAll math functions work with the tuple-in-list format required by Erlang's OpenGL bindings.","ref":"readme.html#math-library"},{"type":"extras","title":"Examples - EAGL","doc":"","ref":"readme.html#examples"},{"type":"extras","title":"Interactive Examples Runner - EAGL","doc":"```bash\n./priv/scripts/run_examples\n```","ref":"readme.html#interactive-examples-runner"},{"type":"extras","title":"Individual Examples - EAGL","doc":"```elixir\n# Math library demonstrations (terminal output)\nEAGL.Examples.Math.run_example()\n\n# 3D teapot with Phong shading (OpenGL window)\nEAGL.Examples.Teapot.run_example()\n\n# LearnOpenGL tutorials (OpenGL windows)\nEAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise1.run_example()\nEAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise2.run_example()\nEAGL.Examples.LearnOpenGL.GettingStarted.HelloTriangleExercise3.run_example()\n```","ref":"readme.html#individual-examples"},{"type":"extras","title":"Requirements - EAGL","doc":"- **Elixir**: 1.14 or later\n- **Erlang/OTP**: 25 or later (with wx support - included in standard distributions)\n- **OpenGL**: 3.3 or later (for modern shader support)","ref":"readme.html#requirements"},{"type":"extras","title":"Platform-specific Notes - EAGL","doc":"#### All Platforms\nEAGL uses Erlang's built-in `wx` module for windowing, which is included with standard Erlang/OTP installations. No additional GUI libraries need to be installed.\n\n#### Linux\nEnsure you have OpenGL drivers installed:\n```bash\n# Ubuntu/Debian\nsudo apt-get install libgl1-mesa-dev libglu1-mesa-dev\n\n# Fedora/RHEL\nsudo dnf install mesa-libGL-devel mesa-libGLU-devel\n```\n\n#### macOS\nOpenGL is included with macOS. No additional setup required.\n\n#### Windows  \nOpenGL is typically available through graphics drivers. If you encounter issues, ensure your graphics drivers are up to date.","ref":"readme.html#platform-specific-notes"},{"type":"extras","title":"Installation - EAGL","doc":"1. Clone the repository:\n   ```bash\n   git clone https://github.com/yourusername/eagl.git\n   cd eagl\n   ```\n\n2. Install dependencies:\n   ```bash\n   mix deps.get\n   ```\n\n3. Compile the project:\n   ```bash\n   mix compile\n   ```\n\n4. Run tests to verify everything works:\n   ```bash\n   mix test\n   ```\n\n5. Try the examples:\n   ```bash\n   ./priv/scripts/run_examples\n   ```","ref":"readme.html#installation"},{"type":"extras","title":"Project Structure - EAGL","doc":"```\nlib/\n├── eagl/                   # Core EAGL modules\n│   ├── buffer.ex           # VAO/VBO helper functions\n│   ├── const.ex            # OpenGL constants\n│   ├── error.ex            # Error checking and reporting\n│   ├── math.ex             # GLM-style math library\n│   ├── model.ex            # 3D model management\n│   ├── obj_loader.ex       # Wavefront OBJ parser\n│   ├── shader.ex           # Shader compilation\n│   ├── window.ex           # Window management\n│   └── window_behaviour.ex # Window callback behavior\n├── examples/               # Example applications\n│   ├── math_example.ex     # Math library demonstrations\n│   ├── teapot_example.ex   # 3D teapot rendering\n│   └── learnopengl/        # LearnOpenGL tutorial ports\n└── wx/                     # wxWidgets constants\ntest/\n├── eagl/                   # Unit tests for EAGL modules\n└── eagl_test.exs           # Integration tests\npriv/\n├── models/                 # 3D model files (.obj)\n├── scripts/                # Convenience scripts\n│   └── run_examples        # Unified examples runner\n└── shaders/                # GLSL shader files\n    └── learnopengl/        # LearnOpenGL tutorial shaders\n```","ref":"readme.html#project-structure"},{"type":"extras","title":"Features - EAGL","doc":"- ✅ **Shader Management**: Automatic compilation, linking, and error reporting\n- ✅ **3D Model Loading**: Wavefront OBJ format with normals and texture coordinates\n- ✅ **Math Library**: GLM-compatible vectors, matrices, quaternions with full OpenGL integration\n- ✅ **Buffer Helpers**: Wings3D-inspired VAO/VBO management functions\n- ✅ **Error Handling**: Comprehensive OpenGL error checking and reporting\n- ✅ **Window Management**: Cross-platform window creation with wxWidgets\n- ✅ **Event Handling**: Resize, close, and paint events\n- ✅ **Resource Cleanup**: Automatic cleanup of OpenGL resources\n- ✅ **LearnOpenGL Examples**: Direct ports of popular OpenGL tutorials\n- ✅ **Testing**: Full test suite with OpenGL context mocking","ref":"readme.html#features"},{"type":"extras","title":"Roadmap - EAGL","doc":"The current focus is to:\n\n- [ ] Port all the Learning OpenGL examples, adding helper functions when necessary\n- [ ] Load common model types like GLTF\n\nAnd in future:\n\n- [ ] Be able to apply post-processing effects\n- [ ] More extensive camera/lighting/material helpers\n- [ ] Access to a physics engine\n- [ ] Built-in GPU profiling tools","ref":"readme.html#roadmap"},{"type":"extras","title":"Community Contributions Welcome - EAGL","doc":"- Documentation improvements and tutorials\n- Additional LearnOpenGL tutorial ports\n- Platform-specific optimizations\n- Example applications and demos","ref":"readme.html#community-contributions-welcome"},{"type":"extras","title":"Contributing - EAGL","doc":"1. Fork the repository\n2. Create a feature branch (`git checkout -b feature/amazing-feature`)\n3. Commit your changes (`git commit -m 'Add amazing feature'`)\n4. Push to the branch (`git push origin feature/amazing-feature`)\n5. Open a Pull Request","ref":"readme.html#contributing"},{"type":"extras","title":"License - EAGL","doc":"This project is licensed under the MIT License - see the [LICENSE](LICENSE) file for details.","ref":"readme.html#license"},{"type":"extras","title":"Acknowledgments - EAGL","doc":"- [Learn OpenGL](https://learnopengl.com) for excellent OpenGL tutorials\n- [Wings3D](https://wings3d.com) for inspiration and helper function patterns - the name EAGL(e) is a tip of the hat to this project\n- The Erlang/OTP team for wxWidgets bindings\n- The Elixir community for inspiration and support, particularly the [Elixir Sydney/Australia User Group](https://https://elixir.sydney)\n- [Cursor](https://cursor.com) and Claude Sonnet for giving me the patience to get to running code and port the Learning OpenGL examples","ref":"readme.html#acknowledgments"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2025 Robin Hiliard\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}